package net.t2code.t2codelib.BUNGEE.system.config;

import net.t2code.t2codelib.BUNGEE.api.yaml.T2CBconfigWriter;
import net.t2code.t2codelib.BUNGEE.system.T2CodeBMain;
import net.t2code.t2codelib.T2CconfigItem;
import net.t2code.t2codelib.Util;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class T2CBlibConfig {

    public enum VALUES implements T2CconfigItem{
        updateTimer("updateCheck.timerInMin", 60,true,"In this option you can set the time interval in minutes in which updates should be checked."),
        seePreReleaseUpdates("updateCheck.seePreReleaseUpdates", true,true,"In this option you can set whether you want to receive and display beta and snapshot versions in the update check."),

        apiCommandGUIEnable("api.commandGUI.enable", false, true,"With this option you activate the api interface for the T2C-CommandGUI plugin."),
        apiAutoResponse("api.autoResponse.enable", false,true,"With this option you activate the api interface for the T2C-AutoResponse plugin."),
        apiOpSecurity("api.opSecurity.enable", false,true,"With this option you activate the api interface for the T2C-OPSecurity plugin."),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final List<String> comments;

        VALUES(String path, Object value,boolean forceSet, String... comments) {
            this.path = path;
            this.value = value;
            this.forceSet=forceSet;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(){
        try {
            ConvertT2CBlibConfig.convert();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        T2CBconfigWriter.createConfig(new File(T2CodeBMain.getPlugin().getDataFolder(), "config.yml"), VALUES.values(), Util.getConfigLogo());
    }

}
