package net.t2code.t2codelib.SPIGOT.system.cmd;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import net.t2code.t2codelib.Util;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.plugin.Plugin;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

import static net.t2code.t2codelib.SPIGOT.api.dev.T2CdevelopmentTool.removeLastChar;

public class Development implements Listener {
    @EventHandler
    public void onChat(AsyncPlayerChatEvent e) {
        String[] args = e.getMessage().split(" ");
        if (args.length == 0) {
            return;
        }
        if (!args[0].equals("_t2code_")) {
            return;
        }
        if (!(boolean) T2CLibConfig.VALUES.developerTool.getValue()) {
            T2Csend.player(e.getPlayer(), Util.getPrefix() + " The Development Tool is disabled.");
        }
        e.setCancelled(true);
        t2cPls(e.getPlayer());
    }

    protected static void t2cPls(Player player) {
        String msg = "<red>T<gray>2</gray>Code</red> <dark_purple>Development</dark_purple><br>"
        + T2CmcVersion.getMcVersion() + "<br>(" + Bukkit.getPluginManager().getPlugins().length + ") ";
        ArrayList<Plugin> plugins = new ArrayList<>();
        Collections.addAll(plugins, Bukkit.getPluginManager().getPlugins());
        plugins.sort(Comparator.comparing(Plugin::getName));
        for (Plugin plugin : plugins) {
            String plName = plugin.getDescription().getName();
            String hover = "<blue>" + plugin.getDescription().getName() + "</blue><br>" +
                    "<green>Version:</green> <gold>" + plugin.getDescription().getVersion() + "</gold><br>" +
                    "<green>APIVersion:</green> <gold>" + plugin.getDescription().getAPIVersion() + "</gold><br>" +
                    "<green>Authors:</green> <gold>" + plugin.getDescription().getAuthors() + "</gold><br>" +
                    "<green>SoftDepend:</green> <gold>" + plugin.getDescription().getSoftDepend() + "</gold><br>" +
                    "<green>Depend:</green> <gold>" + plugin.getDescription().getDepend() + "</gold><br>" +
                    "<green>LoadBefore:</green> <gold>" + plugin.getDescription().getLoadBefore() + "</gold><br>" +
                    "<green>Website:</green> <gold>" + plugin.getDescription().getWebsite() + "</gold>";
            String plSt = "<hover:show_text:'" + hover + "'>" + plugin.getName() + "</hover>";

            if (plugin.getDescription().getWebsite() != null && !plugin.getDescription().getWebsite().equalsIgnoreCase("null")) {
                plSt = "<click:open_url:'" + plugin.getDescription().getWebsite() + "'>" + plSt + "</click>";
            }
            if (plugin.isEnabled()) {
                if (plName.contains("T2C-") || Util.getT2cPlugins().contains(plName)) {
                    msg = msg + "<dark_green>" + plSt + "</dark_green>, ";
                } else msg = msg + "<green>" + plSt + "</green>, ";
            } else if (plName.contains("T2C-") || Util.getT2cPlugins().contains(plName)) {
                msg = msg + "<dark_red>" + plSt + "</dark_red>, ";
            } else msg = msg + "<red>" + plSt + "</red>, ";
        }
        T2Csend.player(player, removeLastChar(msg, 2));
    }


}
