package net.t2code.t2codelib.VELOCITY.api.messages;

import com.velocitypowered.api.command.CommandSource;
import com.velocitypowered.api.proxy.Player;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.title.Title;
import net.t2code.t2codelib.VELOCITY.system.config.T2CVlibConfig;
import org.jetbrains.annotations.Nullable;
import org.slf4j.Logger;

import java.time.Duration;
import java.util.ArrayList;
import java.util.List;

public class T2CVsend {

    public static void console(Logger logger, String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        logger.info(msg);
    }

    public static void player(Player player, String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        player.sendMessage(Component.text(msg));
    }

    public static void sender(CommandSource sender, String msg) {
        if (msg == null || msg.contains("[empty]")) return;
        sender.sendMessage(Component.text(msg));
    }

    public static void console(Logger logger, Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) continue;
            logger.info(msg);
        }
    }

    public static void player(Player player, Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) continue;
            player.sendMessage(Component.text(msg));
        }
    }


    public static void sender(CommandSource sender, Object object) {
        for (String msg : list(object)) {
            if (msg == null || msg.contains("[empty]")) return;
            sender.sendMessage(Component.text(msg));
        }
    }

    public static void title(Player player, @Nullable String title, @Nullable String subtitle, Integer fadeIn, Integer stay, Integer fadeOut) {
        Component titleComponent = title != null ? Component.text(title) : Component.empty();
        Component subtitleComponent = subtitle != null ? Component.text(subtitle) : Component.empty();

        Title.Times times = Title.Times.times(Duration.ofSeconds(fadeIn == null ? 1 : fadeIn), Duration.ofSeconds(stay == null ? 3 : stay), Duration.ofSeconds(fadeOut == null ? 1 : fadeOut));
        Title playerTitle = Title.title(titleComponent, subtitleComponent, times);

        player.showTitle(playerTitle);
    }


    public static void debugmsg(Logger logger, String msg) {
        logger.warn(msg);
    }

    public static void debug(Logger logger, String msg) {
        if (!(boolean)T2CVlibConfig.VALUES.debug.getValue()) return;
        logger.warn(msg);
    }

    public static void info(Logger logger, String msg) {
        logger.info(msg);
    }

    public static void warning(Logger logger, String msg) {
        logger.warn(msg);
    }

    public static void error(Logger logger, String msg) {
        logger.error(msg);
    }

    private static ArrayList<String> list(Object object) {
        ArrayList<String> list = new ArrayList<>();

        if (object instanceof List) {
            list = (ArrayList<String>) object;
        }
        if (object instanceof String) {
            list.add((String) object);
        }
        return list;
    }
}
