// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.pluginMessaging.commandgui;

import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.DisconnectEvent;
import com.velocitypowered.api.event.connection.PostLoginEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.server.RegisteredServer;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.slf4j.Logger;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class T2CVapiCGUI {

    private static ProxyServer server;
    private static Logger logger;

    public T2CVapiCGUI(ProxyServer server, Logger logger) {
        T2CVapiCGUI.server = server;
        T2CVapiCGUI.logger = logger;
        server.getChannelRegistrar().register(T2CodeVMain.cguiopl);
    }


    @Subscribe
    public void onJoin(PostLoginEvent event) {
        Player player = event.getPlayer();
        sendToSpigotPlayer(player.getUsername(), true);
    }

    @Subscribe
    public void onDisconnect(DisconnectEvent event) {
        Player player = event.getPlayer();
        sendToSpigotPlayer(player.getUsername(), false);
    }

    public void sendToSpigotPlayer(String name, Boolean join) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            if (join) {
                output.writeUTF("join");
            } else {
                output.writeUTF("left");
            }
            output.writeUTF(name);
        } catch (IOException e) {
            logger.warn(e.getMessage());
        }
        byte[] data = stream.toByteArray();
        for (RegisteredServer server : server.getAllServers()) {
            server.sendPluginMessage(T2CodeVMain.cguiopl, data);
        }
    }

    public static void sendToSpigotDeleteAll() {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF("clear");
            output.writeUTF("");
        } catch (IOException e) {
            logger.warn(e.getMessage());
        }
        byte[] data = stream.toByteArray();
        for (RegisteredServer server : server.getAllServers()) {
            server.sendPluginMessage(T2CodeVMain.cguiopl, data);
        }
    }
}