// This class was created by JaTiTV.

package net.t2code.t2codelib.VELOCITY.api.proxyPlayers;



import com.velocitypowered.api.event.Subscribe;
import com.velocitypowered.api.event.connection.DisconnectEvent;
import com.velocitypowered.api.event.connection.PluginMessageEvent;
import com.velocitypowered.api.event.connection.PostLoginEvent;
import com.velocitypowered.api.proxy.Player;
import com.velocitypowered.api.proxy.ProxyServer;
import com.velocitypowered.api.proxy.server.RegisteredServer;
import net.t2code.t2codelib.SPIGOT.api.bungeePlayers.T2CbungeePlayersEnum;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.system.T2CodeVMain;
import org.slf4j.Logger;

import java.io.*;


public class T2CVPlayers {

    public static ProxyServer server = T2CodeVMain.getServer();
    public static Logger logger = T2CodeVMain.getLogger();

    @Subscribe
    public void onJoin(PostLoginEvent e) {
        sendToSpigotPlayer(e.getPlayer().getUsername(), T2CbungeePlayersEnum.JOIN, "");
    }

    @Subscribe
    public void onDisconnect(DisconnectEvent e) {
        sendToSpigotPlayer(e.getPlayer().getUsername(), T2CbungeePlayersEnum.QUIT, "");
    }

    public void sendToSpigotPlayer(String name, T2CbungeePlayersEnum value, String uuid) {
        switch (value) {
            case JOIN:
            case QUIT:
                sendToSpigotPlayerExecute(name, value, uuid);
                break;
            case GIVEALL:
                StringBuilder input = new StringBuilder();
                for (Player player : server.getAllPlayers()) {
                    input.append(player.getUsername()).append(";");
                }
                sendToSpigotPlayerExecute(input.toString(), T2CbungeePlayersEnum.GIVEALL, uuid);
                break;
        }
    }

    private void sendToSpigotPlayerExecute(String name, T2CbungeePlayersEnum value, String uuid) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(value.name());
            output.writeUTF(name);
            output.writeUTF(uuid);
        } catch (IOException e) {
        logger.error (e.getMessage());
        }
        T2CVsend.debug(logger, "PluginMessage received channel: t2c:bonlp");
        T2CVsend.debug(logger, "PluginMessage received subChannel: " + value.name());
        T2CVsend.debug(logger, "PluginMessage received input: " + name);
        T2CVsend.debug(logger, "PluginMessage received input2/uuid: " + uuid);
        byte[] data = stream.toByteArray();
        for (RegisteredServer server : server.getAllServers()) {
            server.sendPluginMessage(T2CodeVMain.bonlp, data);
        }

    }

    public static void sendToSpigotDeleteAll() {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);
        try {
            output.writeUTF(T2CbungeePlayersEnum.CLEAR.name());
            output.writeUTF("");
            output.writeUTF("");
        } catch (IOException e) {
            logger.error(e.getMessage());
        }
        byte[] data = stream.toByteArray();
        for (RegisteredServer server : server.getAllServers()) {
            server.sendPluginMessage(T2CodeVMain.bonlp, data);
        }
    }

    @Subscribe
    public void onPluginMessage(PluginMessageEvent event) {
        if (event.getIdentifier() != T2CodeVMain.bonlp) {
            return;
        }
        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(event.getData()));

        try {
            T2CbungeePlayersEnum subChannel = T2CbungeePlayersEnum.valueOf(stream.readUTF());
            String input = stream.readUTF();

            T2CVsend.debug(logger, "PluginMessage received channel: " + T2CodeVMain.bonlp);
            T2CVsend.debug(logger, "PluginMessage received subChannel: " + subChannel.name());
            T2CVsend.debug(logger, "PluginMessage received input/uuid: " + input);

            sendToSpigotPlayer("", subChannel, input);
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}